;; Galois group calculation
(setf Vars '(u12 u13 u23 p q r x1 x2 x3))
	     
(setf 
    f12 "1-u12*x1+u12*x2"
    f13 "1-u13*x1+u13*x3"
    f23 "1-u23*x2+u23*x3"
    a "x1^3+p*x1^2+q*x1+r"
    b "x2^3+p*x2^2+q*x2+r"
    c "x3^3+p*x3^2+q*x3+r"
    rel1 "p^2-q"
    rel2 "0"
    rel3 "0"
    )

(setf n 6)				;number of vars to eliminate
(setf primary-order #'lex>)
(setf secondary-order #'lex>)

(setf order (elimination-order
	     n
	     :primary-order primary-order
	     :secondary-order secondary-order))

(setf F (remove nil (mapcar #'(lambda (s) (parse-string-to-sorted-alist s vars order))
			    (list f12 f13 f23 a b c rel1 rel2 rel3))))

(poly-print (cons '[ f) vars)
(terpri)
;Gb:=gbasis(F,Vars,plex);
(setf gb (elimination-ideal F n :order order :top-reduction-only nil))
(poly-print (cons '[ gb) vars)
